import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import dori.jasper.engine.*;
import dori.jasper.engine.data.JRBeanCollectionDataSource;
import dori.jasper.engine.export.JRHtmlExporter;
import dori.jasper.engine.export.JRHtmlExporterParameter;
import dori.jasper.engine.export.JRXlsExporter;
import dori.jasper.engine.export.JRXlsExporterParameter;

/**
 * BindApp
 */
public class BindApp {
	/**
	 * C
	 */
	public static void main(String[] args) throws Exception {

		// t@C
		String name = "BindReport";

		// RpC
		System.out.print("[compile]");
		JasperReport jasperReport =
			JasperCompileManager.compileReport(name + ".xml");
		System.out.println("OK!");

		// JasperPrintIuWFNg̐
		// ̃IuWFNg|[ǧɂȂ܂B
		System.out.print("[fill]");
		JRReportFont reportFont = jasperReport.getFonts()[0];
		reportFont.setSize(16);
		Map parameters = new HashMap();
		parameters.put("ReportTitle", "ݒnꗗ\");
		parameters.put("SubReportTitle", "15Nx");

		ArrayList list = new ArrayList();
		list.add(new Prefecture("kC", "Dy"));
		list.add(new Prefecture("X", "X"));
		list.add(new Prefecture("茧", ""));
		list.add(new Prefecture("{錧", ""));
		list.add(new Prefecture("Hc", "Hc"));
		list.add(new Prefecture("R`", "R`"));
		list.add(new Prefecture("", ""));
		list.add(new Prefecture("錧", ""));
		list.add(new Prefecture("Ȗ،", "Fs{"));
		list.add(new Prefecture("Qn", "O"));
		list.add(new Prefecture("ʌ", ""));
		list.add(new Prefecture("t", "t"));
		list.add(new Prefecture("s", ""));
		list.add(new Prefecture("_ސ쌧", "l"));
		list.add(new Prefecture("V", "V"));
		list.add(new Prefecture("xR", "xR"));
		list.add(new Prefecture("ΐ쌧", ""));
		list.add(new Prefecture("䌧", ""));
		list.add(new Prefecture("R", "b{"));
		list.add(new Prefecture("쌧", ""));
		list.add(new Prefecture("򕌌", ""));
		list.add(new Prefecture("É", "É"));
		list.add(new Prefecture("m", "É"));
		list.add(new Prefecture("Od", ""));
		list.add(new Prefecture("ꌧ", ""));
		list.add(new Prefecture("s{", "s"));
		list.add(new Prefecture("{", ""));
		list.add(new Prefecture("Ɍ", "_"));
		list.add(new Prefecture("ޗǌ", "ޗ"));
		list.add(new Prefecture("a̎R", "a̎R"));
		list.add(new Prefecture("挧", ""));
		list.add(new Prefecture("", "]"));
		list.add(new Prefecture("R", "R"));
		list.add(new Prefecture("L", "L"));
		list.add(new Prefecture("R", "R"));
		list.add(new Prefecture("", ""));
		list.add(new Prefecture("쌧", ""));
		list.add(new Prefecture("Q", "R"));
		list.add(new Prefecture("m", "m"));
		list.add(new Prefecture("", ""));
		list.add(new Prefecture("ꌧ", ""));
		list.add(new Prefecture("茧", ""));
		list.add(new Prefecture("F{", "F{"));
		list.add(new Prefecture("啪", "啪"));
		list.add(new Prefecture("{茧", "{"));
		list.add(new Prefecture("", ""));
		list.add(new Prefecture("ꌧ", "ߔe"));

		JRDataSource dataSource = new JRBeanCollectionDataSource(list);
		JasperPrint jasperPrint =
			JasperFillManager.fillReport(jasperReport, parameters, dataSource);
		System.out.println("OK!");

		// v^ň
		System.out.print("[Print]");
		JasperPrintManager.printReport(jasperPrint, true);
		System.out.println("OK!");

		// PDFt@C̏o
		System.out.print("[PDF]");
		JasperExportManager.exportReportToPdfFile(jasperPrint, name + ".pdf");
		System.out.println("OK!");

		// HTMLt@C̏o
		System.out.print("[HTML]");
		JRHtmlExporter htmlExporter = new JRHtmlExporter();
		htmlExporter.setParameter(
			JRExporterParameter.JASPER_PRINT,
			jasperPrint);
		htmlExporter.setParameter(
			JRExporterParameter.OUTPUT_WRITER,
			new OutputStreamWriter(
				new FileOutputStream(name + ".html"),
				"UTF-8"));
		htmlExporter.setParameter(
			JRXlsExporterParameter.IS_ONE_PAGE_PER_SHEET,
			Boolean.FALSE);
		htmlExporter.setParameter(
			JRHtmlExporterParameter.IS_OUTPUT_IMAGES_TO_DIR,
			Boolean.TRUE);
		htmlExporter.setParameter(
			JRHtmlExporterParameter.IMAGES_DIR_NAME,
			"images");
		htmlExporter.setParameter(
			JRHtmlExporterParameter.IMAGES_URI,
			"images/");
		htmlExporter.exportReport();
		System.out.println("OK!");

		// Excelt@C̏o
		System.out.print("[EXCEL]");
		JRXlsExporter exporter = new JRXlsExporter();
		exporter.setParameter(JRExporterParameter.JASPER_PRINT, jasperPrint);
		exporter.setParameter(
			JRExporterParameter.OUTPUT_FILE_NAME,
			name + ".xls");
		exporter.setParameter(
			JRXlsExporterParameter.IS_ONE_PAGE_PER_SHEET,
			Boolean.TRUE);
		exporter.exportReport();
		System.out.println("OK!");

		System.exit(0);
	}

}
